if Array.length Sys.argv < 2
     then raise ( Invalid_argument "Un u0 est demandé" ) ;;
let u0 = int_of_string Sys.argv.(1) ;;

open Adressage_arbres ;;

(*
Paramètre : n entier positif
Génère u_n tel que décrit dans l'énoncé
*)
let rec u ( n : int ) : int =
  if n == 0 then u0 else 15091 * ( u ( n - 1) ) mod 64007 ;;

(*
Paramètre = n : entier positif
Génère A_n étiqueté par les ( l_i, m_i ), tels que décrit dans l'énoncé.
*)
let a ( n : int ) : arbre =
  (* Paramètre = l : prochaine étiquette à donner lors du parcour *)
  let rec creation_et_adressage ( l : int ) ( n : int ) : arbre =
    if n == 0 then Feuille ( l, l )
    else
      let fils_g =
        creation_et_adressage ( l + 1 ) ( ( u ( 2 * n ) ) mod n ) in
      let _, m_g = adresse_racine fils_g in
      let fils_d =
        creation_et_adressage ( m_g + 1 ) ( ( u ( 2 * n + 1 ) ) mod n ) in
      let _, m_d = adresse_racine fils_d in
      Noeud ( l, m_d, fils_g, fils_d ) in
  creation_et_adressage 0 n ;;

Printf.printf "Question 1 : a) %i  b) %i  c) %i \n"
  ( u 10 ) ( u 100 ) ( u 1000 ) ;;

let a10 = a 10 ;;
let a100 = a 100 ;;
let a1000 = a 1000 ;;

let noeuds_10, feuilles_10, hauteur_10 = grandeurs_arbre a10 in
let noeuds_100, feuilles_100, hauteur_100 = grandeurs_arbre a100 in
let noeuds_1000, feuilles_1000, hauteur_1000 = grandeurs_arbre a1000 in
Printf.printf
  "Question 2 : a) ( %i, %i, %i )  b) ( %i, %i, %i )  c) ( %i, %i, %i )\n"
  noeuds_10 feuilles_10 hauteur_10
  noeuds_100 feuilles_100 hauteur_100
  noeuds_1000 feuilles_1000 hauteur_1000 ;;

let _, m_10 = chercher_noeud a10 3 in
let _, m_100 = chercher_noeud a100 9 in
let _, m_1000 = chercher_noeud a1000 30 in
Printf.printf "Question 3 : a)  %i  b) %i  c) %i\n" m_10 m_100 m_1000 ;;

let d_10 = distance a10 3 9 in
let d_100 = distance a100 5 30 in
let d_1000 = distance a1000 30 90 in
Printf.printf "Question 4 : a)  %i  b) %i  c) %i\n" d_10 d_100 d_1000 ;;
